%% Deep Learning In 5 Lines of Code
%% Load pre-trained CNN
% Pre-trained CNNs are deep networks that are already trained on thousands of 
% different images. They can work for classification "right out of the box." 
% 
% There are several networks available from our <https://www.mathworks.com/add-ons/ALEXNET/ 
% Add-Ons> section under the home tab. We will use a pretrained model called <https://en.wikipedia.org/wiki/AlexNet 
% AlexNet>, which is trained on a subsection of the <http://www.image-net.org/ 
% ImageNet> database. It classifies images of 1000 different categories. 

% Load the AlexNet neural network
net = alexnet;
%% Classify image of "peppers"
% This is a great opportunity to inspect the network and look at the input layer. 
% In the command window, type
% 
% >> net.Layers
% 
% There is a size requirement of 227 x 227 for AlexNet. If you try to classify 
% without resizing, you will get an error. Now let's classify an image!
%%
% Load in an image. In this case, use the image of various peppers that comes with MATLAB
im = imread('peppers.png');

% Display the image to see what it looks like
imshow(im);

% Resize the image for AlexNet requirements
imResized = imresize(im,[227 227]);

% Let us know what the image is based on the AlexNet pretrained network
label = classify(net,imResized)
%% 
% As you can see from the result, the network identified the above image 
% as bell peppers.
% 
% 
% 
% _Copyright 2017 The MathWorks, Inc._